
;********************************************************************************
;*   Program SIRZDR24.ASM                                                       *
;*Program nam riadi, men vstupn naptie stabilizovanho zdroja na princpe   *
;*rkovej modulcie ( PWM ). Pre riadenie bo vyuit mikrokontroler AT90S2313 *
;*fi ATMEL. Riadenie je realizovan pomocou tiroch tlaitiek. Dva tlaitka nam *
;*umouj meni, zveova  a zmenova naptie po krokoch t.j.pribline 6 mV. *
;Tieto tlaitka s pripojen na 0. 1. bit portu D. alie dva tlaitka nam      *
;*umouj zmenu naptia po vch skokoch, teda rchlejiu zmenu vstupnho   *
;*naptia. Uveden riadenie je mono poui na rzne zae s ohadom na dovo-  *
;*len prdov odber koncovho stupa.                                          *                                               *
;********************************************************************************
                                                                        
        .NOLIST	
	.INCLUDE "2313def.inc"	
	.LIST	
	.CSEG	;kdov segment
	.DEF REG=r20	  ;pracovn register        
        .DEF ACC=R19      ;akultor = register r19       
	
	ldi reg,$00       ; PORT D = vstupn port
       out ddrd,reg 
       LDI REG,RAMEND	
	OUT SPL,REG	  ;nastav SP na koniec RAM
	LDI REG,$08	
	OUT DDRB,REG	  ;aktivuj portB na vystup
	LDI REG,0b10000001	;8bitov PWM
	OUT TCCR1A,REG	
	LDI REG,0b00000011      ;preddelika 8
	OUT TCCR1B,REG	
	CLR REG	
	OUT OCR1AH,REG	        ;OCR1AH=$00
	
       
        ldi acc,$f0 ;poiaton stav pre ACC ( sirku impulzov )
zac:    sbis pind,0 ;tlaitko pripojen na 0.b
        rjmp roz    ;portu D - zvovanie rky jemnm
        rcall caka  ;krokom
opp1:   sbic pind,0 
        rjmp opp1   ;oetrenie zkmitov tlaitka     
        rjmp nac1   
roz:    sbis pind,1 ;tlaitko pripojen na 1. bit portu D 
        rjmp roz1   ;pre zmenovanie rky impulzov jjemnm
        rcall caka  ;krokom
opp2:   sbic pind,1 
        rjmp opp2   ;oetrenie zkmitov tlaitka  
        rjmp nac2  
roz1:   sbis pind,4 ;tlaitko pripojen na 1. bit portu D 
        rjmp roz4   ;pre zmenovanie rky impulzov jjemnm
        rcall caka  ;krokom 
opp4:   sbic pind,4  
        rjmp opp4    ;oetrenie zkmitov tlaitka     
        rjmp nac4
roz4:   sbis pind,5  ;tlaitko pripojen na 1. bit portu D 
        rjmp op1     ;pre zmenovanie rky impulzov jjemnm
        rcall caka   ;krokom
opp5:   sbic pind,5
        rjmp opp5    ;oetrenie zkmitov tlaitka 
        rjmp nac5

op1:    clr reg        ;vynulovanie reg. R31, vyssi byt porovnavacieho     
        adc r31,reg    ;registra citaca/casovaca    
        out ocr1ah,reg ;      "               
        out ocr1al,acc ;zapisanie obsahu acc do nizsieho bytu porovn.reg.
        rjmp zac  
   
nac1:   ldi reg,$01   ;hodnota kroku ( 1 ) do acc  
        add acc,reg   ;naitanie novej hodnoty do acc, pripotanim kroku 
        cpi acc,$ff   ;ak je via hodnota ako 0EaH zapi do acc slo
        brne op1      ; 0FFH - v skoku na nvestie rovno0
        rjmp rovn0
        
nac2:   ldi reg,$01    ;hodnota kroku ( 1 ) do acc 
        sub acc,reg    ;naitanie novej hodnoty do acc, odtanim kroku 
        cpi acc,$00    
        brne op1       ;05H - v skoku na nvestie rovno1
        rjmp rovn1

nac4:   ldi reg,$08   ;hodnota kroku (8 ) do acc  
        add acc,reg   ;naitanie novej hodnoty do acc, pripotanim kroku 
        cpi acc,$e0   ;ak je via hodnota ako 0E0H zapi do acc slo
        brsh rovn4    ; 0F0H - v skoku na nvestie rovno4
        rjmp op1

nac5:   ldi reg,$08    ;hodnota kroku ( 4 ) do acc 
        sub acc,reg    ;naitanie novej hodnoty do acc, odtanim kroku 
        cpi acc,$09    
        brlo rovn5     ;08H - v skoku na nvestie rovno5
        rjmp op1

rovn0:  ldi acc,$fe  
        rjmp op1
 
rovn1:  ldi acc,$01
        rjmp op1

rovn4:  ldi acc,$f0  
        rjmp op1
 
rovn5:  ldi acc,$09
        rjmp op1
        
caka:    ldi r17,$02  ; oneskorenie 
nav1:    dec r17
         brne nav1
         ret  	

